#include "globus_gridftp_server_s3_base.h"

int main()
{
    const char *plain[] = {
        "foo",
        "bar"
    };
    const char *md5_in[] = {
        // printf foo | openssl dgst -md5
        "acbd18db4cc2f85cedef654fccc4a4d8",
        // printf bar | openssl dgst -md5
        "37b51d194a7513e45b56f6524f2d51f2"
    };
    const char *md5_out[] = {
        // printf foo | openssl dgst -md5 -binary | openssl enc -base64
        "rL0Y20zC+Fzt72VPzMSk2A==",
        // printf bar | openssl dgst -md5 -binary | openssl enc -base64
        "N7UdGUp1E+RbVvZSTy1R8g=="
    };
    size_t test_count = sizeof(md5_in) / sizeof(md5_in[0]);
    char md5_testval[25];
    int failed=0;

    globus_result_t result;

    printf("1..%zd\n", test_count);
    for (size_t i = 0; i < test_count; i++)
    {
        result = globus_i_s3_md5sum_encode(md5_in[i], md5_testval);
        if (result == GLOBUS_SUCCESS)
        {
            if (strcmp(md5_testval, md5_out[i]) == 0)
            {
                printf("ok %zd - %s\n", i+1, plain[i]);
                continue;
            }
        }

        printf("not ok %zd - %s\n", i+1, plain[i]);
        failed++;
    }

    return failed;
}
